Name:           spring-installer
Version:        20090316
Release:        10%{?dist}
Summary:        Installer for the Spring game's maps and mods

Group:          Amusements/Games
License:        GPLv3+
URL:            http://www.caspring.org
Source0:        http://files.caspring.org/release/spring-installer_%{version}.orig.tar.gz
Patch0:         spring-installer-20090316-systemcamlzip.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
ExcludeArch:    sparc64 s390 s390x

BuildRequires:  ocaml, ocaml-findlib, ocaml-extlib-devel, ocaml-lablgtk-devel
BuildRequires:  ocaml-ocamlnet-devel, ocaml-pcre-devel, chrpath, desktop-file-utils
BuildRequires:  gtk2-devel
%if 0%{?fedora} >= 11
BuildRequires:  ocaml-zip-devel >= 1.04
%endif

# For execstack
BuildRequires:  prelink

# For the mime package to associate files with spring-installer
Requires:       spring
# Spring does not build on PPC, exclude it here too
ExcludeArch:    ppc ppc64

%description
Spring Installer is a GTK+ program that will install your Spring mods
and maps for you.

%package -n     ca-installer
Summary:        Installer and updater for the C.A. Spring mod
Group:          Amusements/Games
# ca-installer is completely useless without spring itself
Requires:       spring
Requires:       hicolor-icon-theme

%description -n ca-installer
This package contains an automated installer and updater for the
Complete Annihilation Spring mod.


%prep
%setup -q
%if 0%{?fedora} >= 11
%patch0 -p0 -b .systemcamlzip
%endif
find camlsevenzip/libsevenzip -type f -exec chmod -x '{}' \;


%build
# Author says "If make is run with -j > 1 then compilation may fail"
#make %{?_smp_mflags}
make PREFIX=%{_prefix} GAMESBIN="bin"


%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_bindir}
mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications
mkdir -p $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/128x128/apps/
make PREFIX=%{_prefix} \
     GAMESBIN="bin" \
     DESTDIR=$RPM_BUILD_ROOT \
     install_spring-installer \
     install_ca-installer

### Desktop files
# Spring-installer
desktop-file-install \
        --dir $RPM_BUILD_ROOT%{_datadir}/applications \
        --delete-original \
        $RPM_BUILD_ROOT%{_datadir}/applications/spring-installer.desktop
# CA-installer
sed -i -e 's/^Name=/Name=Spring /g' \
        $RPM_BUILD_ROOT%{_datadir}/applications/ca-installer.desktop
desktop-file-install \
        --dir $RPM_BUILD_ROOT%{_datadir}/applications \
        --add-category StrategyGame \
        --delete-original \
        $RPM_BUILD_ROOT%{_datadir}/applications/ca-installer.desktop

# Fix rpath. Very hard to do otherwise with ocaml
chrpath -d $RPM_BUILD_ROOT%{_bindir}/*
# Fix rpmlint warning about "executable stack". See Fedora bug #450551
execstack -c $RPM_BUILD_ROOT%{_bindir}/*


%post
# MimeType entry in the desktop file
update-desktop-database &> /dev/null || :

%postun
# MimeType entry in the desktop file
update-desktop-database &> /dev/null || :

%post -n ca-installer
# Icons
touch --no-create %{_datadir}/icons/hicolor &>/dev/null || :

%postun -n ca-installer
# Icons
if [ $1 -eq 0 ] ; then
    touch --no-create %{_datadir}/icons/hicolor &>/dev/null
    gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
fi

%posttrans -n ca-installer
gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%doc COPYING
%{_bindir}/spring-installer
%{_datadir}/applications/*spring-installer.desktop

%files -n ca-installer
%defattr(-,root,root,-)
%doc COPYING
%{_bindir}/ca-installer
%{_datadir}/icons/hicolor/*/*/ca-installer.png
%{_datadir}/applications/*ca-installer.desktop


%changelog
* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 20090316-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Tue Dec 06 2011 Adam Jackson <ajax@redhat.com> - 20090316-9
- Rebuild for new libpng

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 20090316-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 20090316-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Apr 16 2009 S390x secondary arch maintainer <fedora-s390x@lists.fedoraproject.org>
- ExcludeArch sparc64, s390, s390x as we don't have OCaml on those archs
  (added sparc64 per request from the sparc maintainer)

* Sat Apr 04 2009 Aurelien Bompard <abompard@fedoraproject.org> 20090316-6
- fix patch and buildreq

* Sat Apr 04 2009 Aurelien Bompard <abompard@fedoraproject.org> 20090316-5
- fix versioned dependency

* Sun Mar 22 2009 Aurelien Bompard <abompard@fedoraproject.org> 20090316-4
- rebuild

* Tue Mar 17 2009 Aurelien Bompard <abompard@fedoraproject.org> 20090316-3
- use system camlzip on F11+

* Mon Mar 16 2009 Aurelien Bompard <abompard@fedoraproject.org> 20090316-2
- fix scriptlets
- fix permissions in camlsevenzip/libsevenzip
- package the COPYING file as %%doc

* Mon Mar 16 2009 Aurelien Bompard <abompard@fedoraproject.org> 20090316-1
- new version, with license information
- update icon scriptlets

* Wed Feb 04 2009 Aurelien Bompard <abompard@fedoraproject.org> 20090119-2
- Require spring
- Build only on archs where spring is available

* Mon Jan 19 2009 Aurelien Bompard <abompard@fedoraproject.org> 20090119-1
- version 20090119
- fix rpmlint executable-stack warning

* Mon Jan 19 2009 Aurelien Bompard <abompard@fedoraproject.org> 20090115-1
- version 20090115

* Sat Jan 17 2009 Aurelien Bompard <abompard@fedoraproject.org> 20081228-2
- drop vendor from desktop files

* Thu Jan 01 2009 Aurelien Bompard <abompard@fedoraproject.org> 20081228-1
- initial package
